;;;changes the insunit setting in block definitions
;;;1/2014 knut hohenberg, no rights reserved
;;;4/2017 changed behavior of the "all" option to ignore anonymous and externally referenced blocks
;;;remaining problem: if units in model and paper space differ, the "all" option might still produce unwanted results

(defun C:FixBlockUnits ( / sset blklst blknme blkins kwd unit n x)
 (prompt "Select block insertions (return for all) : ")
 (setq sset (ssget '((0 . "INSERT"))))
 (if (not sset)
  (prompt "\nCAUTION: this will change the units setting in all blocks defined in the drawing")
 )
 (initget "unitless mm cm m km inch feet miles")
 (setq kwd (getkword "\nUnits: [unitless m cm mm km in ft mile]: "))
 (cond
  ((= kwd "unitless") (setq unit 0))
  ((= kwd "in") (setq unit 1))
  ((= kwd "ft") (setq unit 2))
  ((= kwd "mile") (setq unit 3))
  ((= kwd "mm") (setq unit 4))
  ((= kwd "cm") (setq unit 5))
  ((= kwd "m") (setq unit 6))
  ((= kwd "km") (setq unit 7))
 )
 (if unit
  (progn
   (setq blklst '() n 0)
   (vl-load-com)
   (if sset
    (progn
     (while (setq blkins (ssname sset n))
      (setq blknme (cdr (assoc 2 (entget blkins))))
      (if (not (member blknme blklst))
       (setq blklst (cons blknme blklst))
      )
      (setq n (1+ n))
     )
     (vlax-for x (vla-get-Blocks (vla-get-activedocument (vlax-get-acad-object)))
      (if (member (vla-get-name x) blklst)
       (vlax-put-property x "Units" unit)
      )
     )
     (prompt (strcat "\n" (itoa n) " block definitions have been converted to " kwd))
    )
    (progn
     (vlax-for x
      (vla-get-Blocks (vla-get-activedocument (vlax-get-acad-object)))
      (if
       (and
        (/= "*" (substr (vla-get-name x) 1 1))
        (or
         (not (setq blkent (tblsearch "BLOCK" (vla-get-name x))))
         (and (/= 4 (logand 4 (cdr (assoc 70 blkent)))) (/= 16 (logand 16 (cdr (assoc 70 blkent)))))
        )
       )
       (vlax-put-property x "Units" unit)
      )
     )
     (prompt (strcat "\nAll block definitions have been converted to " kwd))
    )
   )
  )
 )
 (princ)
)
